# class ActiveSupport::LogSubscriber

ActiveSupport::LogSubscriber is an object set to consume ActiveSupport::Notifications with the sole purpose of logging them. The log subscriber dispatches notifications to a registered object based on its given namespace.

An example would be Active Record log subscriber responsible for logging queries:

    module ActiveRecord
      class LogSubscriber < ActiveSupport::LogSubscriber
        def sql(event)
          "#{event.payload[:name]} (#{event.duration}) #{event.payload[:sql]}"
        end
      end
    end

And it’s finally registered as:

    ActiveRecord::LogSubscriber.attach_to :active_record

Since we need to know all instance methods before attaching the log subscriber, the line above should be called after your `ActiveRecord::LogSubscriber` definition.

After configured, whenever a “sql.active_record” notification is published, it will properly dispatch the event (ActiveSupport::Notifications::Event) to the sql method.

Log subscriber also has some helpers to deal with logging and automatically flushes all logs when the request finishes (via action_dispatch.callback notification) in a Rails environment.

### Constants

BLACK

  Colors

BLUE
BOLD
CLEAR

  Embed in a String to clear all previous ANSI sequences.

CYAN
GREEN
MAGENTA
RED
WHITE
YELLOW

### Public Class Methods

attach_to(namespace, log_subscriber=new, notifier=ActiveSupport::Notifications) click to toggle source

    # File lib/active_support/log_subscriber.rb, line 59
    def attach_to(namespace, log_subscriber=new, notifier=ActiveSupport::Notifications)
      log_subscribers << log_subscriber
      @@flushable_loggers = nil

      log_subscriber.public_methods(false).each do |event|
        next if 'call' == event.to_s

        notifier.subscribe("#{event}.#{namespace}", log_subscriber)
      end
    end

flush_all!() click to toggle source

Flush all ::log_subscribers’ logger.

    # File lib/active_support/log_subscriber.rb, line 83
    def flush_all!
      flushable_loggers.each { |log| log.flush }
    end

flushable_loggers() click to toggle source

    # File lib/active_support/log_subscriber.rb, line 74
    def flushable_loggers
      @@flushable_loggers ||= begin
        loggers = log_subscribers.map(&:logger)
        loggers.uniq!
        loggers.select { |l| l.respond_to?(:flush) }
      end
    end

log_subscribers() click to toggle source

    # File lib/active_support/log_subscriber.rb, line 70
    def log_subscribers
      @@log_subscribers ||= []
    end

logger() click to toggle source

    # File lib/active_support/log_subscriber.rb, line 55
    def logger
      @logger ||= Rails.logger if defined?(Rails)
    end

### Public Instance Methods

call(message, *args) click to toggle source

    # File lib/active_support/log_subscriber.rb, line 88
    def call(message, *args)
      return unless logger

      method = message.split('.').first
      begin
        send(method, ActiveSupport::Notifications::Event.new(message, *args))
      rescue Exception => e
        logger.error "Could not log #{message.inspect} event. #{e.class}: #{e.message}"
      end
    end

### Protected Instance Methods

color(text, color, bold=false) click to toggle source

Set color by using a string or one of the defined constants. If a third option is set to true, it also adds bold to the string. This is based on the Highline implementation and will automatically append CLEAR to the end of the returned String.

    # File lib/active_support/log_subscriber.rb, line 115
    def color(text, color, bold=false)
      return text unless colorize_logging
      color = self.class.const_get(color.to_s.upcase) if color.is_a?(Symbol)
      bold  = bold ? BOLD : ""
      "#{bold}#{color}#{text}#{CLEAR}"
    end